import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;
import java.util.Enumeration;
import java.util.Vector;


/*
 * This is the "Identity Provider servlet".
 * It is just a dummy servlet to show the communication between the different components in the deployment
 * of the proposed authentication system. Ideally, the IdP should be realized as a Liberty Alliance IdP implementing
 * Sun's Access Manager, Lasso or something similar.
 *
 * @author Hvard Holje
 */
public class IDP extends HttpServlet {

	//The response message to send to client
	String message;

	boolean userAuthenticated = false;
	Vector authenticatedUsers = new Vector();

	/*
	 * Process the incoming request
	 */
	public void doGet(HttpServletRequest request, HttpServletResponse response) throws IOException, ServletException{


		// Retrieve the session object corresponding to this request.
		HttpSession session = request.getSession();

		if (session.isNew()) {

			System.out.println("Session isNew");

			// Retrieve the SRES which is passed to us as a header parameter.

			String SRES = request.getHeader("SRES");
			System.out.print("SRES: " + SRES);

			// Now look up the corresponding user information and check whether user
			// is authenticated against the IDP or not

			userAuthenticated = lookupUser(SRES);


			if(userAuthenticated) {
				String SA = session.getId();
				authenticatedUsers.add((String)SA);
				message = SA;

			}

			else {
				session.invalidate();
				message = "Not authenticated..";
			}


			// Send the message to the client.
			response.setContentType("text/plain");
			response.setContentLength(message.length());
			PrintWriter out = response.getWriter();
			out.println(message+"\r\n");
			System.out.println(message);
		}
	}



	/*
	 * This method should perform a lookup of the given SA and verify the claimed authenticity
	 */
	private boolean lookupUser(String SRES) {
		  if(SRES != null) {
			  return true;

		 } else {
			 return false;
		 }
	}

	/*
	 * Treat POST requests similar as GET requests
	 */
	public void doPost(HttpServletRequest request, HttpServletResponse response)
		throws ServletException, IOException {
			doGet(request, response);
	}
}