package com;

import java.io.InputStream;
import javax.microedition.io.Connector;
import javax.microedition.io.HttpConnection;
import core.Controller;

/**
 * Connects to Identity Provider to authenticate the client   
 * @author Hvard Holje
 * @since 16. May 2007
 *
 */
public class IdpProxy extends Thread {
    private Controller controller;
	private String SRES;
    private InputStream is;
    private HttpConnection httpConn;
    private String URL = "http://dellgeopos.item.ntnu.no:8080/ServiceProvider/servlet/IDP";
    
    public IdpProxy(Controller controller, String SRES) {
    	this.controller = controller;
        this.SRES = SRES;
    }
    
    public void run() {
        try {
        	httpConn = (HttpConnection) Connector.open(URL);
        	httpConn.setRequestMethod( HttpConnection.GET );
        	httpConn.setRequestProperty("Content-Type","text/plain" );
        	httpConn.setRequestProperty("SRES", SRES);	
        	
	        is = httpConn.openInputStream();
	        
        	//Get response from server, should receive a cookie
        	StringBuffer sb = new StringBuffer();

        	//loop forever, receiving data
            while (true) {
                int c = 0;

                while (((c = is.read()) != '\n') && (c != -1)) {
                    sb.append((char)c);
                }
       
                // Notifying controller with the result from IdP
                controller.handleIdpResponse(sb.toString());
       
                if (c == -1) {
                    break;
                }
            }

            is.close();
            httpConn.close();
       
        }
        catch (Exception exp) {
            exp.printStackTrace();
        }
    }
   
}   